#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/inotify.h>

int main()
{
	int limit = 8192, ifd, wfd;
	char path[1024];
	int pid;

	ifd = inotify_init();
	assert(ifd > 0);

	pid = fork();
	assert(pid >= 0);

	if (pid > 0)
		return 0;

	memset(path, 0, sizeof path);
	for (int i = 1; i <= limit + 1; i++) {
		snprintf(path, sizeof path - 1, "/tmp/inotify-test/file%d", i);
		wfd = inotify_add_watch(ifd, path, IN_ACCESS);
		if (wfd < 0)
			fprintf(stderr, "failed to add watch on %s: %s\n", path, strerror(errno));
	}

	while (1)
		sleep(1);
}
