#!/bin/sh

base="/tmp/inotify-test"

sudo sysctl -w fs.inotify.max_user_watches=8192

echo -n "Generating test data in $base..."
mkdir -p $base
for i in $(seq 1 8193); do touch $base/file$i; done
echo "done."

echo -n "Generating test unit file..."
cat << EOF | sudo tee /etc/systemd/system/test.service
[Unit]
Description=Test
[Service]
Type=forking
ExecStart=$base/run-test
EOF
echo "done."

echo -n "Compiling test program..."
gcc -std=c99 run-test.c -o $base/run-test
echo "done."

echo -n "Reproducing..."
systemctl daemon-reload
systemctl start test
sleep 1
systemctl stop test
systemctl start test
sleep 1
systemctl stop test
echo "done."
